/*
	$Id: DataCubeLayerData.java 4889 2009-04-06 12:52:39Z nicklas $
	
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg
	
	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/
	
	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.
	
	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.
	
	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

/**
	This class holds information about a single layer in a data cube.
	
	@author Nicklas
	@version 2.0
	@see net.sf.basedb.core.DataCubeLayer
	@see <a href="../../../../../../html/developerdoc/api/data_api.experiments.html">Experiments and analysis overview</a>
	@base.modified $Date: 2009-04-06 14:52:39 +0200 (Mon, 06 Apr 2009) $
	@hibernate.class table="`DataCubeLayers`" lazy="true"
*/
public class DataCubeLayerData
	extends BasicData
{
	public DataCubeLayerData()
	{}

	private DataCubeData dataCube;
	/**
		Get the data cube this layer belongs to.
		@hibernate.many-to-one column="`datacube_id`" not-null="true" outer-join="false" 
			update="false" unique-key="uniquelayer"
	*/
	public DataCubeData getDataCube()
	{
		return dataCube;
	}
	public void setDataCube(DataCubeData dataCube)
	{
		this.dataCube = dataCube;
	}

	private short layerNo;
	/**
		The layer number of this layer in the data cube.
		@hibernate.property column="`layer_no`" type="short" not-null="true" 
			update="false" unique-key="uniquelayer"
	*/
	public short getLayerNo()
	{
		return layerNo;
	}
	public void setLayerNo(short layerNo)
	{
		this.layerNo = layerNo;
	}
	
	private long bytes;
	/**
		The number of bytes the analysed data in this cube occupies on disk.
		@hibernate.property column="`bytes`" type="long" not-null="true"
	*/
	public long getBytes()
	{
		return bytes;
	}
	public void setBytes(long bytes)
	{
		this.bytes = bytes;
	}
}
