/*
  $Id: HardwareData.java 4889 2009-04-06 12:52:39Z nicklas $

	Copyright (C) 2005 Johan Enell, Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

  BASE is free software; you can redistribute it and/or
  modify it under the terms of the GNU General Public License
  as published by the Free Software Foundation; either version 3
  of the License, or (at your option) any later version.

  BASE is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

  You should have received a copy of the GNU General Public License
  along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data;

import java.util.Date;

/**
	This class holds information about a Hardware.
	
	@author enell
	@version 2.0
	@see net.sf.basedb.core.Hardware
	@see <a href="../../../../../../html/developerdoc/api/data_api.wares.html">Hardware and software overview</a>
	@base.modified $Date: 2009-04-06 14:52:39 +0200 (Mon, 06 Apr 2009) $
	@hibernate.class table="`Hardware`" lazy="true"
*/
public class HardwareData
	extends CommonData
	implements RegisteredData
{
	public HardwareData()
	{}
	/*
		From the RegisteredData interface
		-------------------------------------------
	*/
	private Date entryDate;
	public Date getEntryDate()
	{
		return entryDate;
	}
	public void setEntryDate(Date entryDate)
	{
		this.entryDate = entryDate;
	}
	// -------------------------------------------
	
	public static final int MAX_VERSIONSTRING_LENGTH = 255;
	
	private HardwareTypeData hardwareType;
	/**
		@hibernate.many-to-one column="`hardwaretype_id`" not-null="true" outer-join="false"
	*/
	public HardwareTypeData getHardwareType()
	{
		return this.hardwareType;
	}
	public void setHardwareType(HardwareTypeData hardwareType)
	{
		this.hardwareType = hardwareType;
	}
	
	private String versionString;
	/**
		@hibernate.property column="`version_string`" type="string" length="255" not-null="false"
	*/
	public String getVersionString()
	{
		return versionString;
	}
	public void setVersionString(String versionString)
	{
		this.versionString = versionString;
	}
}
