/*
	$Id: UserKeys.java 4889 2009-04-06 12:52:39Z nicklas $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.data.keyring;
import java.io.Serializable;

/**
	Class for mapping the <code>UserKeys</code> table.
	@author Nicklas
	@version 2.0
	@base.modified $Date: 2009-04-06 14:52:39 +0200 (Mon, 06 Apr 2009) $
*/
public final class UserKeys
	extends KeyPermission
	implements Serializable
{

	/**
		
	*/
	private static final long serialVersionUID = 2419369267333836877L;
	private int userId;
	
	/**
		Create a new <code>UserKeys</code> object.
	*/
	public UserKeys()
	{
		super();
	}

	/**
		Get the id of the user.
	*/
	public int getUserId()
	{
		return userId;
	}
	/**
		Set the id of the user.
	*/
	public void setUserId(int userId)
	{
		this.userId = userId;
	}

	/**
		Check if this object is equal to another <code>UserKeys</code>
		object. They are considered to be the same if the user id and the
		key id are the same. The permissions may be different.
	*/
	public boolean equals(Object o)
	{
		if ((o == null) || (getClass() != o.getClass())) return false;
		UserKeys uk = (UserKeys)o;
		return (uk.userId == this.userId) && (uk.keyId == this.keyId);
	}
	
	/**
		Calculate the hash code for the object.
	*/
	public int hashCode()
	{
		return (int)(31*keyId + 17*userId);
	}
}
