/*
	$Id: SqlResultIterator.java 4889 2009-04-06 12:52:39Z nicklas $

	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
*/
package net.sf.basedb.core.query;

import java.sql.SQLException;

/**
	Return the result of a {@link SqlQuery} as an iterator.

	@author Nicklas
	@version 2.0
	@base.modified $Date: 2009-04-06 14:52:39 +0200 (Mon, 06 Apr 2009) $
*/
public interface SqlResultIterator
	extends ResultIterator<SqlResult>
{
	/**
		Get the index number of a selected column. Use this method to
		find the index of a column and then use the <code>SqlResult.getXxx(index)</code> 
		methods to get the value of that column. 
		
		@param name The name of a selected column
		@return The index number
		@throws SQLException If there is an error
	*/
	public int getIndex(String name)
		throws SQLException;

}
