<%-- $Id: edit_bioplate.jsp 5492 2010-11-16 08:47:29Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Martin
	@version 2.10
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.HardwareType"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioPlateType"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.BIOPLATE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	BioPlate bioplate = null;
	
	boolean readCurrentPlateGeometry = true;
	PlateGeometry currentPlateGeometry = null;
	boolean readCurrentBioPlateType = true;
	BioPlateType currentBioPlateType = null;
	
	boolean readCurrentFreezer = true;
	Hardware currentFreezer = null;
	
	// Load recently used items
	List<Hardware> recentFreezers = (List<Hardware>)cc.getRecent(dc, Item.HARDWARE);
	List<PlateGeometry> recentPlateGeometry = (List<PlateGeometry>)cc.getRecent(dc, Item.PLATEGEOMETRY);
	List<BioPlateType> recentBioPlateType = (List<BioPlateType>)cc.getRecent(dc, Item.BIOPLATETYPE);
	
	if (itemId == 0)
	{
		title = "Create bioplate";
		cc.removeObject("item");

		int plateGeometryId = Values.getInt(request.getParameter("plategeometry_id"));
		if (plateGeometryId != 0)
		{
			currentPlateGeometry = PlateGeometry.getById(dc, plateGeometryId);
		}
		else if (cc.getPropertyFilter("plateType.name") != null)
		{
			currentPlateGeometry = Base.getFirstMatching(dc, PlateGeometry.getQuery(), "name", cc.getPropertyFilter("plateGeometry.name"));
		}
		int bioPlateTypeId = Values.getInt(request.getParameter("bioplatetype_id"));
		if (bioPlateTypeId != 0)
		{
			currentBioPlateType = BioPlateType.getById(dc, bioPlateTypeId);
		}
		else if (cc.getPropertyFilter("bioPlateType.name") != null)
		{
			currentBioPlateType = Base.getFirstMatching(dc, BioPlateType.getQuery(), "name", cc.getPropertyFilter("bioPlateType.name"));
		}
		
		int freezerId = Values.getInt(request.getParameter("freezer_id"));
		if (freezerId != 0)
		{
			currentFreezer = Hardware.getById(dc, freezerId);
		}
	}
	else
	{
		bioplate = BioPlate.getById(dc, itemId);
		cc.setObject("item", bioplate);
		title = "Edit bioplate -- " + HTML.encodeTags(bioplate.getName());
		try
		{
			currentPlateGeometry = bioplate.getPlateGeometry();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentPlateGeometry = false;
		}
		try
		{
			currentBioPlateType = bioplate.getBioPlateType();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentBioPlateType = false;
		}
		try
		{
			currentFreezer = bioplate.getFreezer();			
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentFreezer = false;
		}
	}
	if (bioplate != null && !bioplate.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), bioplate);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "BioPlate" tab
		function validateBioPlate()
		{
			var frm = document.forms['bioplate'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			if (frm.plategeometry_id && frm.plategeometry_id.length == 0)
			{
				alert("You must select a plate geometry");
				return false;
			}
			if (frm.bioplatetype_id && frm.bioplatetype_id.length == 0)
			{
				alert("You must select a bio plate type");
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['bioplate'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (annotationsLoaded) 
				{
					Annotations.addModifiedAnnotationsToForm(frames.annotations, frm);
				}
				if (inheritedAnnotationsLoaded)
				{
					Annotations.addInheritedAnnotationsToForm(frames.inheritedAnnotations, frm);
				}
				frm.submit();
			}
		}
		
		var annotationsLoaded = false;
		var inheritedAnnotationsLoaded = false;
		var parentsChanged = false;
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.setActiveTab(tabControlId, tabId))
			{
				if (tabId == 'annotations' && !annotationsLoaded)
				{
					Annotations.loadAnnotateFrame(frames.annotations, '<%=ID%>', '<%=itemType.name()%>', <%=bioplate == null ? 0 : bioplate.getId()%>);
					annotationsLoaded = true;
				}
				else if (tabId == 'inheritedAnnotations' && 
					(parentsChanged || !inheritedAnnotationsLoaded))
				{
					Annotations.loadInheritFrame(frames.inheritedAnnotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, getParents());
					inheritedAnnotationsLoaded = true;
					parentsChanged = false;
				}
			}
		}
		function getParents()
		{
			return new Array();
		}
		function selectPlateGeometryOnClick()
		{
			var frm = document.forms['bioplate'];
			var url = '../../lims/geometries/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setPlateGeometryCallback';
			if (frm.plategeometry_id.length > 0) url += '&item_id='+frm.plategeometry_id[0].value;
			Main.openPopup(url, 'SelectPlateGeometry', 1000, 700);
		}
		function setPlateGeometryCallback(plateGeometryId, name)
		{
			var frm = document.forms['bioplate'];
			var list = frm.plategeometry_id;
			if (list.length < 1 || list[0].disabled) // >
			{
				Forms.addListOption(list, 0, new Option());
			}
			list[0].value = plateGeometryId;
			list[0].text = name;
			list.selectedIndex = 0;
		}
		function selectBioPlateTypeOnClick()
		{
			var frm = document.forms['bioplate'];
			var url = '../bioplatetypes/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setBioPlateTypeCallback';
			if (frm.bioplatetype_id.length > 0) url += '&item_id='+frm.bioplatetype_id[0].value;
			Main.openPopup(url, 'SelectBioPlateType', 1000, 700);
		}
		function setBioPlateTypeCallback(bioPlateTypeId, name)
		{
			var frm = document.forms['bioplate'];
			var list = frm.bioplatetype_id;
			if (list.length < 1 || list[0].disabled) // >
			{
				Forms.addListOption(list, 0, new Option());
			}
			list[0].value = bioPlateTypeId;
			list[0].text = name;
			list.selectedIndex = 0;
		}
		function selectFreezerOnClick()
		{
			var frm = document.forms['bioplate'];
			var url = '../../admin/hardware/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setFreezerCallback';
			if (frm.freezer_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.freezer_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&resetTemporary=1&tmpfilter:INT:hardwareType=<%=SystemItems.getId(HardwareType.FREEZER)%>';
			Main.openPopup(url, 'SelectFreezer', 1000, 700); 
		}
		function setFreezerCallback(freezerId, name)
		{
			var frm = document.forms['bioplate'];
			if (frm.freezer_id.length < 1) // >
			{
				frm.freezer_id[frm.freezer_id.length] = new Option();
			}
			frm.freezer_id[0].value = freezerId;
			frm.freezer_id[0].text = name;
			frm.freezer_id.selectedIndex = 0;
		}
		
		function init()
		{
			var frm = document.forms['bioplate'];
			<%
			if (bioplate == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="bioplate" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*370)+"px;"%>" 
			position="bottom"  remember="<%=bioplate != null%>" switch="switchTab"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Plate" validate="validateBioPlate()" helpid="bioplate.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(bioplate == null ? Values.getString(cc.getPropertyValue("name"), "New bioplate") : bioplate.getName())%>" 
					size="40" maxlength="<%=BioPlate.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Bio plate type</td>
				<td>
					<%
					if (bioplate != null)
					{
						%>
						<%=Base.getEncodedName(currentBioPlateType, !readCurrentBioPlateType)%>
						<%
					}
					else
					{
						%>
						<base:select 
							id="bioplatetype_id"
							clazz="selectionlist unchangeable"
							required="true"
							current="<%=currentBioPlateType%>"
							denied="<%=!readCurrentBioPlateType%>"
							recent="<%=recentBioPlateType%>"
							newitem="true"
							onselect="selectBioPlateTypeOnClick()"
						/>
						<%
					}
					%>
				</td>
			</tr>
			<tr>
				<td class="prompt">Plate geometry</td>
				<td>
					<%
					if (bioplate != null)
					{
						%>
						<%=Base.getEncodedName(currentPlateGeometry, !readCurrentPlateGeometry)%>
						<%
					}
					else
					{
						%>
						<base:select 
							id="plategeometry_id"
							clazz="selectionlist unchangeable"
							required="true"
							current="<%=currentPlateGeometry%>"
							denied="<%=!readCurrentPlateGeometry%>"
							recent="<%=recentPlateGeometry%>"
							newitem="true"
							onselect="selectPlateGeometryOnClick()"
						/>
						<%
					}
					%>
				</td>
			</tr>
			<tr>
				<td class="prompt">Freezer</td>
				<td>
					<base:select 
						id="freezer_id"
						clazz="selectionlist"
						required="false"
						current="<%=currentFreezer%>"
						denied="<%=!readCurrentFreezer%>"
						recent="<%=recentFreezers%>"
						newitem="<%=bioplate == null%>"
						onselect="selectFreezerOnClick()"
						onchange="freezerOnChange()"
					/>
				</td>
			</tr>
			<tr>
				<td class="prompt">Barcode</td>
				<td><input <%=clazz%> type="text" name="barcode" 
					value="<%=HTML.encodeTags(bioplate == null ? Values.getString(cc.getPropertyValue("barcode"), "") : bioplate.getBarcode())%>" 
					size="40" maxlength="<%=BioPlate.MAX_BARCODE_LENGTH%>"></td>
			</tr>	
			<tr>
				<td class="prompt">Destroyed</td>
				<td><input type="checkbox" name="destroyed" value="1"
					<%=(bioplate != null && bioplate.isDestroyed()) || (bioplate == null && Values.getBoolean(cc.getPropertyValue("destroyed"))) ? "checked" : ""%>>
				</td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(bioplate == null ? cc.getPropertyValue("description") : bioplate.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'bioplate', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i>
			<%if (bioplate == null) {%><br>
				<i><base:icon image="unchangeable.gif" /> = can't be changed later</i>
				<%}%>
			</div>
		</t:tab>
		
		<t:tab id="annotations" title="Annotations" helpid="annotations.edit">
			<iframe name="annotations" id="idAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>		
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>