<%-- $Id: create_child_bioplate_step1.jsp 5561 2011-02-02 08:43:27Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2011 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.BioPlate"
	import="net.sf.basedb.core.BioPlateEvent"
	import="net.sf.basedb.core.BioPlateEventType"
	import="net.sf.basedb.core.BioPlateType"
	import="net.sf.basedb.core.PlateGeometry"
	import="net.sf.basedb.core.MeasuredBioMaterial"
	import="net.sf.basedb.core.Hardware"
	import="net.sf.basedb.core.HardwareType"
	import="net.sf.basedb.core.Protocol"
	import="net.sf.basedb.core.Label"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.FormatterSettings"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="java.util.List"
	import="java.util.Date"
	import="java.util.Collections"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final int sourcePlateId = Values.getInt(request.getParameter("sourceplate_id"));
final ItemContext cc = sc.getCurrentContext(Item.BIOPLATEEVENT, BioPlateEventType.CREATE_BIOMATERIAL);
final DbControl dc = sc.newDbControl();
try
{
	BioPlate sourcePlate = BioPlate.getById(dc, sourcePlateId);
	BioPlateType sourceType = sourcePlate.getBioPlateType();
	Item sourceBioMaterialType = sourceType.getBioMaterialType();
	PlateGeometry sourceGeometry = sourcePlate.getPlateGeometry();
	Hardware sourceFreezer = sourcePlate.getFreezer();
	
	// Load recently used items
	List<Hardware> recentHardware = (List<Hardware>)cc.getRecent(dc, Item.HARDWARE, sourceBioMaterialType.name());
	List<Protocol> recentProtocols = (List<Protocol>)cc.getRecent(dc, Item.PROTOCOL, sourceBioMaterialType.name());
	List<PlateGeometry> recentGeometry = (List<PlateGeometry>)cc.getRecent(dc, Item.PLATEGEOMETRY, sourceBioMaterialType.name());
	List<BioPlateType> recentPlateTypes = (List<BioPlateType>)cc.getRecent(dc, Item.BIOPLATETYPE, sourceBioMaterialType.name());
	List<Hardware> recentFreezers = (List<Hardware>)cc.getRecent(dc, Item.HARDWARE, "freezer");
		
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	final Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	final String dateFormat = FormatterSettings.getDateFormat(sc);
	final String jsDateFormat = HTML.javaScriptEncode(dateFormat);
	final String htmlDateFormat = HTML.encodeTags(dateFormat);
	%>
	<base:page type="popup" title="Create child bioplate - step 1/2">
	<base:head>
		<script language="javascript">
	
		function nextStep()
		{
			var frm = document.forms['main'];
			var childType = frm.child_biomaterial_type[frm.child_biomaterial_type.selectedIndex].value;
			if (Main.trimString(frm.event_name.value) == '')
			{
				alert("You must enter a name for the new event.");
				frm.event_name.focus();
				return;
			}
			if (Main.trimString(frm.number_of_plates.value) == '')
			{
				alert("You must enter the number of plates that was created.");
				frm.number_of_plates.focus();
				return;
			}
			if (Main.trimString(frm.plate_name_prefix.value) == '')
			{
				alert("You must enter a name prefix for the new plates.");
				frm.plate_name_prefix.focus();
				return;
			}
			if (frm.plategeometry_id.length == 0 && childType != 'HYBRIDIZATION')
			{
				alert("You must select a plate geometry");
				frm.plategeometry_id.focus();
				return false;
			}
			if (frm.bioplatetype_id.length == 0 && childType != 'HYBRIDIZATION')
			{
				alert("You must select a plate type");
				frm.bioplatetype_id.focus();
				return false;
			}
			frm.submit();
			
		}
			
		function selectHardwareOnClick()
		{
			var frm = document.forms['main'];
			var url = '../../admin/hardware/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setHardwareCallback';
			if (frm.hardware_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.hardware_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&resetTemporary=1';
			Main.openPopup(url, 'SelectHardware', 1000, 700); 
		}
		function setHardwareCallback(id, name)
		{
			var frm = document.forms['main'];
			var list = frm.hardware_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
	
		function selectProtocolOnClick()
		{
			var frm = document.forms['main'];
			var url = '../../admin/protocols/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setProtocolCallback';
			if (frm.protocol_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.protocol_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&resetTemporary=1';
			Main.openPopup(url, 'SelectProtocol', 1000, 700); 
		}
		function setProtocolCallback(id, name)
		{
			var frm = document.forms['main'];
			var list = frm.protocol_id;
			if (list.length < 2 || list[1].value == '0') // >
			{
				Forms.addListOption(list, 1, new Option());
			}
			list[1].value = id;
			list[1].text = name;
			list.selectedIndex = 1;
		}
		
		function selectPlateGeometryOnClick()
		{
			var frm = document.forms['main'];
			var url = '../../lims/geometries/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setPlateGeometryCallback';
			if (frm.plategeometry_id.length > 0) url += '&item_id='+frm.plategeometry_id[0].value;
			url += '&resetTemporary=1';
			Main.openPopup(url, 'SelectPlateGeometry', 1000, 700);
		}
		function setPlateGeometryCallback(id, name)
		{
			var frm = document.forms['main'];
			var list = frm.plategeometry_id;
			if (list.length < 1 || list[0].value == '0') // >
			{
				Forms.addListOption(list, 0, new Option());
			}
			list[0].value = id;
			list[0].text = name;
			list.selectedIndex = 0;
		}

		function selectBioPlateTypeOnClick()
		{
			var frm = document.forms['main'];
			var url = '../bioplatetypes/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setBioPlateTypeCallback';
			if (frm.bioplatetype_id.length > 0) url += '&item_id='+frm.bioplatetype_id[0].value;
			Main.openPopup(url, 'SelectBioPlateType', 1000, 700);
		}
		function setBioPlateTypeCallback(bioPlateTypeId, name)
		{
			var frm = document.forms['main'];
			var list = frm.bioplatetype_id;
			if (list.length < 1 || list[0].disabled) // >
			{
				Forms.addListOption(list, 0, new Option());
			}
			list[0].value = bioPlateTypeId;
			list[0].text = name;
			list.selectedIndex = 0;
		}
		function selectFreezerOnClick()
		{
			var frm = document.forms['main'];
			var url = '../../admin/hardware/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setFreezerCallback';
			if (frm.freezer_id.length > 1) 
			{
				var id = Math.abs(parseInt(frm.freezer_id[1].value));				
				url += '&item_id='+id;
			}
			url += '&resetTemporary=1&tmpfilter:INT:hardwareType=<%=SystemItems.getId(HardwareType.FREEZER)%>';
			Main.openPopup(url, 'SelectFreezer', 1000, 700); 
		}
		function setFreezerCallback(freezerId, name)
		{
			var frm = document.forms['main'];
			if (frm.freezer_id.length < 2) // >
			{
				frm.freezer_id[frm.freezer_id.length] = new Option();
			}
			frm.freezer_id[1].value = freezerId;
			frm.freezer_id[1].text = name;
			frm.freezer_id.selectedIndex = 1;
		}
		function childTypeOnChange()
		{
			var frm = document.forms['main'];
			var childType = frm.child_biomaterial_type[frm.child_biomaterial_type.selectedIndex].value;
			Main.showHide('labelDiv', childType == 'LABELEDEXTRACT');
			var isHyb = childType == 'HYBRIDIZATION';
			Main.showHide('originalQuantityDiv', !isHyb);
			Main.showHide('freezerDiv', !isHyb);
			Main.showHide('plateTypeDiv', !isHyb);
			Main.showHide('geometryDiv', !isHyb);
			Main.showHide('numArraysDiv', isHyb);
		}
		
		function init()
		{
			childTypeOnChange();
		}
		
		</script>
	</base:head>
	<base:body onload="init()">
	
		<h3>Create child bioplate - step 1/2</h3>
		<div class="boxedbottom" style="height: <%=(int)(scale*500)%>px; background: #e0e0e0;">
			<form name="main" action="create_child_bioplate_step2.jsp" method="post">
			<input type="hidden" name="ID" value="<%=ID%>">
			<input type="hidden" name="sourceplate_id" value="<%=sourcePlateId%>">
			
			<h4>Event</h4>
			<table cellspacing="0" border="0" width="100%">
			<tr valign="top">
			<td>
				<table class="form" cellspacing="0">
				<tr>
					<td class="prompt" style="width: 90px;">Event name</td>
					<td><input <%=requiredClazz%> type="text" name="event_name" 
						value="Create child plate" 
						size="40" maxlength="<%=BioPlateEvent.MAX_NAME_LENGTH%>"></td>
				</tr>
				<tr>
					<td class="prompt">Event date</td>
					<td>
						<table border="0" cellspacing="0" cellpadding="0">
						<tr>
						<td>
							<input <%=clazz%> type="text" name="event_date" 
								value="<%=HTML.encodeTags(dateFormatter.format(new Date()))%>" 
								size="20" maxlength="20" title="Enter date in format: <%=htmlDateFormat%>">
							&nbsp;
						</td>
						<td>
						<base:button 
							onclick="<%="Dates.selectDate('Event date', 'main', 'event_date', null, '"+jsDateFormat+"')"%>"
							image="calendar.png"
							title="Calendar&hellip;" 
							tooltip="Select a date from a calendar" 
						/>
						</td>
						</tr>
						</table>
					</td>
				</tr>
				<tr>
					<td class="prompt">Protocol</td>
					<td>
						<base:select 
							id="protocol_id"
							clazz="selectionlist"
							required="false"
							current="<%=null%>"
							recent="<%=recentProtocols%>"
							onselect="selectProtocolOnClick()"
						/>
					</td>
				</tr>
				<tr>
					<td class="prompt">Hardware</td>
					<td>
						<base:select 
							id="hardware_id"
							clazz="selectionlist"
							required="false"
							current="<%=null%>"
							recent="<%=recentHardware%>"
							onselect="selectHardwareOnClick()"
						/>
					</td>
				</tr>
				</table>
			</td>
			<td>
				<b>Description</b><br>
				<textarea <%=clazz%> rows="4" cols="40" name="event_description" wrap="virtual"
					></textarea>
				<a href="javascript:Main.zoom('Event description', 'main', 'event_description')"
					title="Edit in larger window"><base:icon image="zoom.gif" /></a>
			</td>
		</tr>
		<tr>
			<td colspan="2">
				<h4>Child biomaterial</h4>
			</td>
		</tr>
		<tr valign="top">
			<td>
				<table class="form" cellspacing="0">
				<tr>
					<td class="prompt">Type</td>
					<td>
						<select name="child_biomaterial_type" class="required" onchange="childTypeOnChange()">
							<%
							if (sourceBioMaterialType == Item.SAMPLE)
							{
								%>
								<option value="SAMPLE">Sample → Sample
								<option value="EXTRACT" selected>Sample → Extract
								<%
							}
							else if (sourceBioMaterialType == Item.EXTRACT)
							{
								%>
								<option value="EXTRACT">Extract → Extract
								<option value="LABELEDEXTRACT" selected>Extract → Labeled extract
								<%
							}
							else if (sourceBioMaterialType == Item.LABELEDEXTRACT)
							{
								%>
								<option value="LABELEDEXTRACT">Labled extract → Labeled extract
								<option value="HYBRIDIZATION" selected>Labled extract → Hybridization
								<%
							}
							%>
						</select>
					</td>
				</tr>
				<%
				if (sourceBioMaterialType == Item.EXTRACT)
				{
					final ItemQuery<Label> labelsQuery = Label.getQuery();
					labelsQuery.order(Orders.asc(Hql.property("name")));
					labelsQuery.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
					labelsQuery.setCacheResult(true);
					final List<Label> labels = labelsQuery.list(dc);
					%>
					<tr id="labelDiv">
						<td class="prompt">Label</td>
						<td>
							<select name="label_id" size="1" class="required"
								style="width: 20em;">
								<%
								for (Label label : labels)
								{
									%>
									<option value="<%=label.getId()%>"><%=HTML.encodeTags(label.getName())%>
									<%
								}
								%>
							</select>
						</td>
					</tr>
					<%
				}
				%>
				
				<tr id="originalQuantityDiv">
					<td class="prompt">Original quantity</td>
					<td><input <%=clazz%> type="text" name="original_quantity" size="12" 
						maxlength="10" onkeypress="return Numbers.numberOnly(event)"> (µg)</td>
				</tr>
				<tr>
					<td class="prompt">Used from parent</td>
					<td><input <%=clazz%> type="text" name="used_quantity" size="12" 
						maxlength="10" onkeypress="return Numbers.numberOnly(event)"> (µg)</td>
				</tr>
				</table>
			</td>
			<td>
				<b>Description</b><br>
				<textarea <%=clazz%> rows="4" cols="40" name="child_description" wrap="virtual"
					></textarea>
				<a href="javascript:Main.zoom('Biomaterial description', 'main', 'child_description')"
					title="Edit in larger window"><base:icon image="zoom.gif" /></a>
			</td>
		</tr>

		<tr>
			<td colspan="2">
				<h4>Child plates</h4>
			</td>
		</tr>
		<tr valign="top">
			<td>
				<table class="form" cellspacing="0">
				<tr>
					<td class="prompt">No. of plates</td>
					<td><input <%=requiredClazz%> type="text" name="number_of_plates" value="1" 
						size="12" maxlength="2" 
						onkeypress="return Numbers.integerOnly(event)"><i></i></td>
				</tr>
				<tr>
					<td class="prompt" style="width: 90px;">Name prefix</td>
					<td><input <%=requiredClazz%> type="text" name="plate_name_prefix" 
						value="New plate." 
						size="40" maxlength="<%=BioPlate.MAX_NAME_LENGTH%>"></td>
				</tr>
				<tr id="geometryDiv">
					<td class="prompt">Geometry</td>
					<td>
						<base:select 
							id="plategeometry_id"
							clazz="selectionlist"
							required="true"
							current="<%=sourceGeometry%>"
							recent="<%=recentGeometry%>"
							newitem="true"
							onselect="selectPlateGeometryOnClick()"
						/>
					</td>
				</tr>
				<tr id="numArraysDiv" style="display: none;">
					<td class="prompt">Number of arrays/hyb</td>
					<td><input <%=requiredClazz%> type="text" name="num_arrays" size="12" 
						value="<%=sourceGeometry.getRows() %>"
						maxlength="10" onkeypress="return Numbers.numberOnly(event)"></td>
				</tr>
				<tr id="plateTypeDiv">
					<td class="prompt">Plate type</td>
					<td>
						<base:select 
							id="bioplatetype_id"
							clazz="selectionlist"
							required="true"
							current="<%=null%>"
							recent="<%=recentPlateTypes%>"
							newitem="true"
							onselect="selectBioPlateTypeOnClick()"
						/>
					</td>
				</tr>
				<tr id="freezerDiv">
					<td class="prompt">Freezer</td>
					<td>
						<base:select 
							id="freezer_id"
							clazz="selectionlist"
							required="false"
							current="<%=sourceFreezer%>"
							recent="<%=recentFreezers%>"
							newitem="true"
							onselect="selectFreezerOnClick()"
							onchange="freezerOnChange()"
						/>
					</td>
				</tr>
				</table>
			</td>
			<td>
				<b>Description</b><br>
				<textarea <%=clazz%> rows="4" cols="40" name="plate_description" wrap="virtual"
					></textarea>
				<a href="javascript:Main.zoom('Plate description', 'main', 'plate_description')"
					title="Edit in larger window"><base:icon image="zoom.gif" /></a>
			</td>
		</tr>

		</table>


		</div>
		</form>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="nextStep()" title="Next" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>