/* $Id: plugin.js 4510 2008-09-11 20:03:48Z jari $
	------------------------------------------------------------------
	Copyright (C) 2008 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	JavaScript functions for managing plugins and configurations.

	@author Nicklas
	@version 2.0
*/
var Quantities = new QuantitiesClass();

function QuantitiesClass()
{
	this.allQuantities = new Array();
	
	this.populateLists = function(quantitiesList, unitsList, quantityId, unitId)
	{
		if (unitId && !quantityId) 
		{
			var quantity = this.findQuantity(unitId);
			if (quantity) quantityId = quantity.id;
		}
		for (var i = 0; i < this.allQuantities.length; i++)
		{
			var quantity = this.allQuantities[i];
			if (quantity.units.length > 0)
			{
				var option = new Option(quantity.name, quantity.id, false, quantityId == quantity.id);
				quantitiesList[quantitiesList.length] = option;
				quantitiesList[quantitiesList.length - 1].quantity = quantity;
			}
		}
		this.updateUnitsList(quantitiesList[quantitiesList.selectedIndex].quantity, unitsList, unitId);
	}
	
	this.updateUnitsList = function(quantity, list, unitId)
	{
		list.length = 0;
		if (quantity)
		{
			if (quantity.units.length > 0)
			{
				for (var i = 0; i < quantity.units.length; i++)
				{
					var unit = quantity.units[i];
					list[list.length] = new Option(unit.name + ' - ' + unit.symbol, unit.id, false, unitId == unit.id);
					list[list.length-1].unit = unit;
				}
			}
		}
	}
	
	this.findQuantity = function(unitId)
	{
		for (var i = 0; this.allQuantities.length; i++)
		{
			var quantity = this.allQuantities[i];
			for (var j = 0; j < quantity.units.length; j++)
			{
				if (quantity.units[j].id == unitId) return quantity;
			}
		}
		return null;
	}
}


// Create a new quantity object
function Quantity(id, name)
{
	this.id = id;
	this.name = name;
	
	this.units = new Array();
	
	Quantities.allQuantities[Quantities.allQuantities.length] = this;

	this.addUnit = function(id, name, symbol)
	{
		this.units[this.units.length] = new Unit(id, name, symbol);
	}

}

function Unit(id, name, symbol)
{
	this.id = id;
	this.name = name;
	this.symbol = symbol;
}

