<%-- $Id: news.jsp 5479 2010-11-08 07:33:46Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Gregory Vincic

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	This page lists all news in case they are too many to be shown
	on the fron page.

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.News"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.servlet.RssNewsFeed"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getSessionControl(pageContext, true);
final String ID = sc.getId();
final DbControl dc = sc.newDbControl();
final String root = request.getContextPath()+"/";
ItemResultList<News> news = null;
String broadcastTitle = (String)application.getAttribute("broadcast.title");
String broadcastMessage = (String)application.getAttribute("broadcast.message");
boolean denyLogin = Boolean.TRUE.equals(application.getAttribute("broadcast.deny-login"));

try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateFormatter(sc);
	%>
	<base:page type="default" title="">
	<base:head styles="login.css">
	</base:head>
	<base:body>
		
		<table border=0 cellspacing=5 cellpadding=0 width="80%" align="center">
		<tr><td><base:icon image="goback.gif" /><a href="<%=root%>/main.jsp?ID=<%=ID%>">Back to login</a></td></tr>
		<tr>
		<td>
			<h3>News and announcements 
			<%
			if (RssNewsFeed.isEnabled()) 
			{
				%><a href="news.rss" 
					title="Subscribe to news from this BASE server"
					><base:icon image="rss.png" /></a>
				<%
			}
			%>
			</h3>
			<div id="news" class="news">
			<%
			if (broadcastTitle != null)
			{
				%>
				<div class="item"><base:icon image="warning.gif" />
					<a name="broadcast"></a>
					<span class="date"><%=dateFormatter.format(new Date())%></span>
					<span class="headline"><%=HTML.encodeTags(broadcastTitle)%><%=denyLogin ? " (login disabled)" : "" %></span><br>
					<span class="text"><%=HTML.niceFormat(broadcastMessage)%></span>
				</div>
				<% 
			}
			ItemQuery<News> query = News.getQuery();
			query.order(Orders.desc(Hql.property("newsDate")));
			query.order(Orders.desc(Hql.property("id")));
			query.setCacheResult(true);
			news = query.list(dc);
			for (News n : news)
			{
				%>
				<div class="item">
					<a name="<%=n.getId() + "-" + n.getVersion()%>"></a>
					<span class="date"><%=dateFormatter.format(n.getNewsDate())%></span>
					<span class="headline"><%=HTML.encodeTags(n.getName())%></span><br>
					<span class="text"><%=Values.getString(n.getDescription())%></span>
				</div>
				<%
			}
			%>
			</div>
		</td>
		</tr>
		<tr><td><base:icon image="goback.gif" /><a href="<%=root%>/main.jsp?ID=<%=ID%>">Back to login</a></td></tr>
		</table>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>

