<%-- $Id: edit_slide.jsp 5498 2010-11-17 10:29:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Häkkinen, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.SystemItems"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ArraySlide"
	import="net.sf.basedb.core.ArrayBatch"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.BaseException"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.edit.EditUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.HashSet"
	import="java.util.Date"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%
final Item itemType = Item.ARRAYSLIDE;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();
try
{
	String title = null;
	ArraySlide slide = null;
	
	boolean readCurrentArrayBatch = true;
	ArrayBatch currentArrayBatch = null;
	int maxIndex = 0;
	
	// Load recently used items
	List<ArrayBatch> recentArrayBatches = (List<ArrayBatch>)cc.getRecent(dc, Item.ARRAYBATCH);

	if (itemId == 0)
	{
		title = "Create array slide";
		cc.removeObject("item");
		int arrayBatchId = Values.getInt(request.getParameter("arraybatch_id"));
		if (arrayBatchId != 0)
		{
			currentArrayBatch = ArrayBatch.getById(dc, arrayBatchId);
		}
		else if (cc.getPropertyFilter("arrayBatch.name") != null)
		{
			currentArrayBatch = Base.getFirstMatching(dc, ArrayBatch.getQuery(), "name", cc.getPropertyFilter("arrayBatch.name"));
		}
		if (currentArrayBatch != null)
		{
			maxIndex = (int)currentArrayBatch.getArraySlides().count(dc);
		}
	}
	else
	{
		slide = ArraySlide.getById(dc, itemId);
		cc.setObject("item", slide);
		title = "Edit array slide -- " + HTML.encodeTags(slide.getName());
		try
		{
			currentArrayBatch = slide.getArrayBatch();
		}
		catch (PermissionDeniedException ex)
		{
			readCurrentArrayBatch = false;
		}
	}
	if (slide != null && !slide.hasPermission(Permission.WRITE))
	{
		throw new PermissionDeniedException(Permission.WRITE, itemType.toString());
	}
	final String clazz = "class=\"text\"";
	final String requiredClazz = "class=\"text required\"";
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, GuiContext.item(itemType), slide);
	ExtensionsInvoker invoker = EditUtil.useEditExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="tabcontrol.js,annotations.js" styles="tabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		// Validate the "ArraySlide" tab
		function validateArraySlide()
		{
			var frm = document.forms['slide'];
			if (Main.trimString(frm.name.value) == '')
			{
				alert("You must enter a name");
				frm.name.focus();
				return false;
			}
			if (frm.arraybatch_id && frm.arraybatch_id[frm.arraybatch_id.selectedIndex].value == 0)
			{
				alert("You must select an array batch");
				return false;
			}
			return true;
		}

		// Submit the form
		function saveSettings()
		{
			var frm = document.forms['slide'];
			if (TabControl.validateActiveTab('settings'))
			{
				if (annotationsLoaded) 
				{
					Annotations.addModifiedAnnotationsToForm(frames.annotations, frm);
				}
				if (inheritedAnnotationsLoaded)
				{
					Annotations.addInheritedAnnotationsToForm(frames.inheritedAnnotations, frm);
				}
				frm.submit();
			}
		}
		
		var annotationsLoaded = false;
		var inheritedAnnotationsLoaded = false;
		var parentsChanged = false;
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.setActiveTab(tabControlId, tabId))
			{
				if (tabId == 'annotations' && !annotationsLoaded)
				{
					Annotations.loadAnnotateFrame(frames.annotations, '<%=ID%>', '<%=itemType.name()%>', <%=slide == null ? 0 : slide.getId()%>);
					annotationsLoaded = true;
				}
				else if (tabId == 'inheritedAnnotations' && 
					(parentsChanged || !inheritedAnnotationsLoaded))
				{
					Annotations.loadInheritFrame(frames.inheritedAnnotations, '<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, getParents());
					inheritedAnnotationsLoaded = true;
					parentsChanged = false;
				}
			}
		}
		
		function getParents()
		{
			var frm = document.forms['slide'];
			var parents = new Array();
			if (frm.arraybatch_id)
			{
				var batchId = Math.abs(parseInt(frm.arraybatch_id[frm.arraybatch_id.selectedIndex].value));
				if (batchId > 0) parents[parents.length] = 'ARRAYBATCH:'+batchId;
			}
			return parents;
		}
		
		function arrayBatchOnChange()
		{
			parentsChanged = true;
		}		
		function selectArrayBatchOnClick()
		{
			var frm = document.forms['slide'];
			var url = '../../lims/arraybatches/index.jsp?ID=<%=ID%>&cmd=UpdateContext&mode=selectone&callback=setArrayBatchCallback';
			if (frm.arraybatch_id.length > 0) url += '&item_id='+frm.arraybatch_id[0].value;
			Main.openPopup(url, 'SelectArrayBatch', 1000, 700);
		}
		function setArrayBatchCallback(id, name)
		{
			var frm = document.forms['slide'];
			var list = frm.arraybatch_id;
			if (list.length < 1 || list[0].value == '0') // >
			{
				Forms.addListOption(list, 0, new Option());
			}
			list[0].value = id;
			list[0].text = name;
			list.selectedIndex = 0;
			parentsChanged = true;
		}

		function init()
		{
			var frm = document.forms['slide'];
			<%
			if (slide == null)
			{
				%>
				frm.name.focus();
				frm.name.select();
				<%
			}
			%>
		}
		</script>
	</base:head>
	<base:body onload="init()">
		<p>
		<form action="index.jsp?ID=<%=ID%>" method="post" name="slide" onsubmit="return false;">
		<input type="hidden" name="cmd" value="UpdateItem">

		<h3 class="docked"><%=title%> <base:help tabcontrol="settings" /></h3>
		<t:tabcontrol id="settings" contentstyle="<%="height: "+(int)(scale*370)+"px;"%>" 
			position="bottom"  remember="<%=slide != null%>" switch="switchTab"
			extensions="<%=invoker%>">
		<t:tab id="info" title="Array slide" validate="validateArraySlide()" helpid="arrayslide.edit">
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">Name</td>
				<td><input <%=requiredClazz%> type="text" name="name" 
					value="<%=HTML.encodeTags(slide == null ? Values.getString(cc.getPropertyValue("name"), "New array slide") : slide.getName())%>" 
					size="40" maxlength="<%=ArraySlide.MAX_NAME_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Barcode</td>
				<td><input <%=clazz%> type="text" name="barcode" 
					value="<%=HTML.encodeTags(slide == null ? Values.getString(cc.getPropertyValue("barcode"), "") : slide.getBarcode())%>" 
					size="40" maxlength="<%=ArraySlide.MAX_BARCODE_LENGTH%>"></td>
			</tr>
			<tr>
				<td class="prompt">Destroyed</td>
				<td><input type="checkbox" name="destroyed" value="1"
					<%=(slide != null && slide.isDestroyed()) || (slide == null && Values.getBoolean(cc.getPropertyValue("destroyed"))) ? "checked" : ""%>>
				</td>
			</tr>
			<tr>
				<td class="prompt">Array batch</td>
				<td>
					<%
					if (slide != null)
					{
						%>
						<%=Base.getEncodedName(currentArrayBatch, !readCurrentArrayBatch)%>
						<%
					}
					else
					{
						%>
						<base:select 
							id="arraybatch_id"
							clazz="selectionlist required"
							required="true"
							current="<%=currentArrayBatch%>"
							denied="<%=!readCurrentArrayBatch%>"
							recent="<%=recentArrayBatches%>"
							newitem="true"
							onselect="selectArrayBatchOnClick()"
							onchange="arrayBatchOnChange()()"
						/>
						<%
					}
					%>
				</td>
			</tr>
			<tr>
				<td class="prompt">Index</td>
				<td><input <%=clazz%> type="text" name="batch_index" value="<%=slide == null ? Values.getInt(cc.getPropertyValue("batchIndex"), maxIndex + 1) : slide.getBatchIndex()%>" 
					size="12" maxlength="10" 
					onkeypress="return Numbers.integerOnly(event)"></td>
			</tr>
			<tr valign=top>
				<td class="prompt">Description</td>
				<td nowrap>
					<textarea <%=clazz%> rows="4" cols="40" name="description" wrap="virtual"
						><%=HTML.encodeTags(slide == null ? cc.getPropertyValue("description") : slide.getDescription())%></textarea>
					<a href="javascript:Main.zoom('Description', 'slide', 'description')"
						title="Edit in larger window"><base:icon image="zoom.gif" /></a>
				</td>
			</tr>
			</table>
			<div align=right>&nbsp;<i><base:icon image="required.gif" /> = required information</i></div>
		</t:tab>
		
		<t:tab id="annotations" title="Annotations" helpid="annotations.edit">
			<iframe name="annotations" id="idAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		
		<t:tab id="inheritedAnnotations" title="Inherited annotations" helpid="annotations.edit.inherited">
		
			<iframe name="inheritedAnnotations" id="idInheritedAnnotations" src="../../common/annotations/wait.jsp" 
				width="100%"  height="<%=(int)(scale*370)%>" frameborder=0 vspace=0 hspace=0
				marginwidth=0 marginheight=0 scrolling="auto" style="overflow: visible"></iframe>
		</t:tab>
		</t:tabcontrol>

		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="saveSettings()" title="Save" /></td>
			<td width="50%"><base:button onclick="window.close()" title="Cancel" /></td>
		</tr>
		</table>
		</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
