<%-- $Id: view.jsp 5426 2010-09-24 09:18:50Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Johan Enell, Nicklas Nordborg
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page pageEncoding="UTF-8" session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.PropertyFilter"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.BioAssay"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.RawDataUtil"
	import="net.sf.basedb.core.ExtendedProperties"
	import="net.sf.basedb.core.ExtendedProperty"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.Formula"
	import="net.sf.basedb.core.IntensityTransform"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.DynamicSpotQuery"
	import="net.sf.basedb.core.DynamicResultIterator"
	import="net.sf.basedb.core.VirtualColumn"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.data.ReporterData"
	import="net.sf.basedb.core.data.RawData"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Dynamic"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Selects"
	import="net.sf.basedb.core.query.Aggregations"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.query.JoinType"
	import="net.sf.basedb.core.query.SqlResult"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.DynamicUtil"
	import="net.sf.basedb.clients.web.ExperimentExplorer"
	import="net.sf.basedb.clients.web.ExperimentExplorer.AnnotationSummary"
	import="net.sf.basedb.clients.web.ExperimentExplorer.AnnotationGroup"
	import="net.sf.basedb.clients.web.WebException"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.formatter.SpotImageFormatter"
	import="net.sf.basedb.clients.web.taglib.table.TableColumn"
	import="java.util.Date"
	import="java.util.List"
	import="java.util.ArrayList"
	import="java.util.LinkedList"
	import="java.util.Collection"
	import="java.util.Arrays"
	import="java.util.Set"
	import="java.util.Map"
	import="java.util.HashMap"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%!
	private static final Item itemType = Item.SPOTDATA;
	private static final String defaultReporterColumns = "name,externalId,symbol,description";
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String root = request.getContextPath();

final int bioAssaySetId = Values.getInt(request.getParameter("bioassayset_id"));
final DbControl dc = sc.newDbControl();
DynamicResultIterator spotData = null;
try
{
	Formatter<Date> dateFormatter = FormatterFactory.getDateTimeFormatter(sc);
	String title = null;
	final BioAssaySet bioAssaySet = BioAssaySet.getById(dc, bioAssaySetId);
	final Experiment experiment = bioAssaySet.getExperiment();
	final RawDataType rawDataType = experiment.getRawDataType();
	final int channels = rawDataType.getChannels();
	final boolean hasRatio = channels == 2;
	final int maxRawMappings = bioAssaySet.getMaxRawMappingsForSpot();
	final IntensityTransform transform = bioAssaySet.getIntensityTransform();
	
	final ExperimentExplorer explorer = ExperimentExplorer.getExplorer(bioAssaySet);
	final ItemContext cc = explorer.getAndSetSpotContext(sc, pageContext);
	final ItemContext reporterContext = explorer.getAndSetReporterContext(sc, null);
	final String subContext = cc.getSubContext();
	
	List<TableColumn> columns = new LinkedList<TableColumn>();
	DynamicUtil.addFormulaColumns(columns, dc, rawDataType, Formula.Type.COLUMN_EXPRESSION, 
		transform, "frm.", "", maxRawMappings == 1);
	DynamicUtil.addExtraColumns(columns, dc, bioAssaySet, "ev", "#", "[Xtra] ");
	if (maxRawMappings == 1)
	{
		DynamicUtil.addRawDataColumns(columns, dc, rawDataType, "raw.", "$", "[Raw] ");
		columns.add(new TableColumn("raw.spotimage", "$id", "raw('id')", Type.INT, 
			"[Raw] Spotimage", "", "auto", false, false, false, null, 
			new SpotImageFormatter(dc, rawDataType, root)));
	}

	final int matchingReporters = explorer.getMatchingReporters(dc);
	int reporterIndex = explorer.getReporterIndex();
	if (reporterIndex >= matchingReporters) reporterIndex = matchingReporters - 1;
	final ReporterData reporter = matchingReporters == 0 ? 
			null : explorer.getReporter(dc, reporterIndex);

	final int matchingPositions = matchingReporters == 0 ? 
			0 : explorer.getNumPositions(dc, reporterIndex);
	
	int positionIndex = explorer.getPositionIndex();
	if (positionIndex >= matchingPositions) positionIndex = matchingPositions - 1;
	final boolean isAveraging = positionIndex == ExperimentExplorer.SPOT_AVG;
	
	final List<AnnotationType> annotationTypes = explorer.getAnnotationTypes(dc, true);
	final Set<Integer> tmp = explorer.getAnnotationTypeIds();
	final Map<AnnotationType, AnnotationSummary> selectedAnnotationTypes = 
		new HashMap<AnnotationType, AnnotationSummary>(tmp.size());
	for (Integer atId : tmp)
	{
		try
		{
			selectedAnnotationTypes.put(AnnotationType.getById(dc, atId), null);
		}
		catch (Throwable t)
		{}
	}

	DynamicUtil.SelectedInfo selected = DynamicUtil.getSelectedColumns(cc, columns, isAveraging);
	
	List<String> sortProperties = null;
	if (isAveraging && cc.getSortProperty() != null)
	{
		// We must check that we are not sorting on a non-averagable property
		sortProperties = new ArrayList<String>(Arrays.asList(cc.getSortProperty().split(",")));
		for (TableColumn tc : columns)
		{
			if (!tc.isAveragable()) sortProperties.remove(tc.getProperty());
		}
		cc.setSortProperty(Values.getString(sortProperties, ",", true));
	}
	
	if (matchingReporters > 0)
	{
		for (Map.Entry<AnnotationType, AnnotationSummary> entry : selectedAnnotationTypes.entrySet())
		{
			entry.setValue(explorer.getAnnotationSummary(dc, entry.getKey()));
		}
		try
		{
			DynamicSpotQuery spotQuery = explorer.getSpotQuery(dc, reporterIndex, positionIndex, selected.selectedColumns);
			spotData = spotQuery.iterate(dc);
		}
		catch (Throwable t)
		{
			cc.setMessage(t.getMessage());
		}
	}
	%>
	<base:page title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,toolbar.css,headertabcontrol.css,path.css,explorer.css">
	<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'spotdata';
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function configureReporterColumns()
		{
			var frm = document.forms['reporter'];
			frm.cmd.value = 'SetReporterColumns';
			Table.configureColumns('<%=ID%>', 'reporter', '<%=itemType.name()%>', '<%=defaultReporterColumns%>', '<%=subContext%>', 'reporter-columns');
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>', '<%=subContext%>');
		}
		function validateReporterIndex()
		{
			var frm = document.forms['reporterIndex'];
			var reporterIndex = parseInt(frm.newReporterIndex.value);
			var maxIndex = <%=matchingReporters%>;
			if (reporterIndex < 1 || reporterIndex > maxIndex)
			{
				alert('The reporter index must be between 1 and ' + maxIndex);
				return false;
			}
			frm.cmd.value = 'SetReporterIndex';
			Forms.createHidden(frm, 'reporterIndex', reporterIndex-1);
			return true;
		}
		function validateSpotIndex()
		{
			var frm = document.forms['spotIndex'];
			var spotIndex = parseInt(frm.newSpotIndex.value);
			var maxIndex = <%=matchingPositions%>;
			if (spotIndex < 1 || spotIndex > maxIndex)
			{
				alert('The spot index must be between 1 and ' + maxIndex);
				return false;
			}
			frm.cmd.value = 'SetSpotIndex';
			Forms.createHidden(frm, 'spotIndex', spotIndex-1);
			return true;
		}
		function annotationTypeOnChange()
		{
			var frm = document.forms['explorer'];
			frm.cmd.value = 'SetAnnotationType';
			frm.submit();
		}
		function viewSearch()
		{
			location.href = '../search/index.jsp?ID=<%=ID%>&bioassayset_id=<%=bioAssaySetId%>';
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'search')
			{
				viewSearch();
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		function assayPlot()
		{
			var url = 'plotter.jsp?ID=<%=ID%>&type=assay';
			url += '&bioAssaySetId=<%=bioAssaySetId%>';
			url += '&reporterIndex=<%=reporterIndex%>';
			url += '&positionIndex=<%=positionIndex%>';
			Main.openPopup(url, 'AssayPlot', 1100, 700);
		}
		function annotationPlot(annotationType)
		{
			var url = 'plotter.jsp?ID=<%=ID%>&type=annotation';
			url += '&bioAssaySetId=<%=bioAssaySetId%>';
			url += '&reporterIndex=<%=reporterIndex%>';
			url += '&positionIndex=<%=positionIndex%>';
			url += '&annotationTypeId=' + annotationType;
			Main.openPopup(url, 'AnnotationPlot', 1100, 700);
		}
	</script>
	</base:head>
	<base:body>
		<p>
		<p:path>
			<p:pathelement title="Experiments" href="<%="../../index.jsp?ID="+ID%>" />
			<p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" 
				href="<%="../../bioassaysets/index.jsp?ID="+ID+"&experiment_id="+experiment.getId()%>" />
			<p:pathelement title="<%=HTML.encodeTags(bioAssaySet.getName())%>" 
				href="<%="../../bioassaysets/index.jsp?ID="+ID+"&cmd=ViewItem&item_id="+bioAssaySetId%>" />
			<p:pathelement title="Explorer" />
		</p:path>
		
		<t:tabcontrol id="explorer" switch="switchTab" remember="false" active="view">
		<t:tab id="search" title="Reporter search" />
		
		<t:tab id="view" title="Reporter view">
		<div class="boxed">
		
		<%
		Collection<PropertyFilter> filters = reporterContext.getPropertyFilters();
		String filter = filters != null && filters.size() > 0 ? 
			"(" + Values.getString(filters, ") AND (", true).replaceAll("@|�", "") + ")" : "- none -";
		%>
		<table class="form">
		<tr>
			<td class="prompt">Filter</td>
			<td>
			<%=HTML.encodeTags(filter)%>
			</td>
		</tr>
		</table>
		
		
		<%
		if (reporter != null)
		{
			%>
			<form name="reporterIndex" action="index.jsp" method="post">
			<input type="hidden" name="ID" value="<%=ID%>">
			<input type="hidden" name="bioassayset_id" value="<%=bioAssaySetId%>">
			<input type="hidden" name="cmd" value="SetReporterIndex">
			<h4 class="docked">Current reporter
						<input name="newReporterIndex" type="text" class="text" value="<%=reporterIndex+1%>" 
				onkeypress="return Numbers.integerOnly(event, true, validateReporterIndex)"
				size="6" maxlength="8" title="Enter a number between 1 and <%=matchingReporters%>">
			of <%=matchingReporters %>
			<%
			if (reporterIndex == 0 || matchingReporters == 0)
			{
				%>
				<base:icon image="first_gray.gif" />
				<base:icon image="previous_gray.gif" />
				<%
			}
			else
			{
				%>
				<a href="index.jsp?ID=<%=ID%>&cmd=SetReporterIndex&bioassayset_id=<%=bioAssaySetId%>&reporterIndex=0"
					title="Go the first reporter"><base:icon image="first.gif" /></a>
				<a href="index.jsp?ID=<%=ID%>&cmd=SetReporterIndex&bioassayset_id=<%=bioAssaySetId%>&reporterIndex=<%=reporterIndex-1%>"
					title="Go the previous reporter"><base:icon image="previous.gif" /></a>
				<%
			}
			%>
			&nbsp;&nbsp;
			<%
			if (reporterIndex == matchingReporters - 1 || matchingReporters == 0)
			{
				%>
				<base:icon image="next_gray.gif" />
				<base:icon image="last_gray.gif" />
				<%
			}
			else
			{
				%>
				<a href="index.jsp?ID=<%=ID%>&cmd=SetReporterIndex&bioassayset_id=<%=bioAssaySetId%>&reporterIndex=<%=reporterIndex+1%>"
					title="Go the next reporter"><base:icon image="next.gif" /></a>
				<a href="index.jsp?ID=<%=ID%>&cmd=SetReporterIndex&bioassayset_id=<%=bioAssaySetId%>&reporterIndex=<%=matchingReporters-1%>"
					title="Go the last reporter"><base:icon image="last.gif" /></a>
				<%
			}
			%>
			</h4>
			</form>
			
			<tbl:toolbar>
				<tbl:button 
					image="columns.gif" 
					onclick="configureReporterColumns()" 
					title="Columns&hellip;" 
					tooltip="Show, hide and re-order reporter columns" 
				/>
			</tbl:toolbar>
		
		<div class="boxedbottom">
		<tbl:table 
			id="reporter" 
			clazz="form" 
			columns="<%=Values.getString(cc.getSetting("reporter-columns"), defaultReporterColumns)%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subcontext="<%=subContext%>"
			>
			<tbl:hidden 
				name="bioassayset_id" 
				value="<%=String.valueOf(bioAssaySetId)%>" 
			/>
			<tbl:columndef id="name" title="Name" show="always" clazz="prompt"/>
			<tbl:columndef id="externalId" title="External ID" clazz="prompt"/>
			<tbl:columndef id="symbol" title="Gene symbol" clazz="prompt"/>
			<tbl:columndef id="lastUpdate" title="Last update" clazz="prompt"/>
			<tbl:columndef id="type" title="Type" clazz="prompt"/>
			<tbl:columndef id="description" title="Description" clazz="prompt"/>
			<%
			List<ExtendedProperty> reporterProperties = ExtendedProperties.getProperties("ReporterData");
			if (reporterProperties != null)
			{
				for (ExtendedProperty ep : reporterProperties)
				{
					String name = ep.getName();
					Formatter formatter = FormatterFactory.getExtendedPropertyFormatter(sc, ep);
					%>
					<tbl:columndef 
						id="<%=ep.getName()%>" 
						title="<%=HTML.encodeTags(ep.getTitle())%>" 
						clazz="prompt" 
						formatter="<%=formatter%>"
					/>
					<%
				}
			}
			%>
			<tbl:form width="2">
				<tbl:cell column="name"><%=Base.getLink(ID, reporter.getName(), Item.REPORTER, reporter.getId(), true)%></tbl:cell>
				<tbl:cell column="externalId"><%=HTML.encodeTags(reporter.getExternalId())%></tbl:cell>
				<tbl:cell column="symbol"><%=HTML.encodeTags(reporter.getSymbol())%></tbl:cell>
				<tbl:cell column="lastUpdate"><%=dateFormatter.format(reporter.getLastUpdate())%></tbl:cell>
				<tbl:cell column="type"><base:propertyvalue dbcontrol="<%=dc%>" item="<%=reporter%>" property="reporterType" /></tbl:cell>
				<tbl:cell column="description"><%=HTML.niceFormat(reporter.getDescription())%></tbl:cell>
				<%
				if (reporterProperties != null)
				{
					for (ExtendedProperty ep : reporterProperties)
					{
						String name = ep.getName();
						Formatter formatter = FormatterFactory.getExtendedPropertyFormatter(sc, ep);
						%>
						<tbl:cell column="<%=ep.getName()%>"><tbl:cellvalue value="<%=reporter.getExtended(name)%>" /></tbl:cell>
						<%
					}
				}
				%>
			</tbl:form>
		</tbl:table>
		</div>
		<%
		}
		else
		{
			%>
			No reporters found.
			<%
		}
		%>
		
		<base:section
			id="annotation"
			title="<%="Annotation summary (" + selectedAnnotationTypes.size() + " selected)"%>"
			context="<%=cc%>"
			>
			<form name="annotationSummary" action="index.jsp" method="POST" onsubmit="return false;">
			<input type="hidden" name="ID" value="<%=ID%>">
			<input type="hidden" name="bioassayset_id" value="<%=bioAssaySetId%>">
			<input type="hidden" name="cmd" value="SetAnnotationType">
				<table border="0" cellspacing="0" cellpadding="0"><tr><td>
				<div class="multiselect">
					<input type="text" class="text" size="40" name="display:annotationTypes"
						title="Click to select experimental factor"><img 
						class="smartimage" src="../../../../images/pull_down.gif" 
						onclick="MultiOptions.activateAndDisplay('annotationSummary','display:annotationTypes')"></div>
					<input type="hidden" name="annotationtype_id" value="">
					</td></tr></table>
				<%
				if (selectedAnnotationTypes.size() > 0)
				{
					for (Map.Entry<AnnotationType, AnnotationSummary> entry : selectedAnnotationTypes.entrySet())
					{
						AnnotationType at = entry.getKey();
						AnnotationSummary summary = entry.getValue();
						%>
						<table border="0" cellspacing="0" cellpadding="2" class="annotationsummary">
						<tr>
							<td class="summaryheader"><%=Base.getLinkedName(ID, at, false, true)%></td>
							<td class="summaryheader"><base:icon
								image="plotter.gif"
								onclick="<%="annotationPlot(" + at.getId() + ")"%>"
								tooltip="Box plot for selected spot data per annotation group"
							/></td>
							<%
							for (AnnotationGroup ag : summary.getAnnotationGroups())
							{
								%>
								<td class="groupheader" style="background: <%=ag.getColor()%>;" width="50px">
								<%=ag.getTitle()%>
								</td>
								<%
							}
							%>
							</tr>
							<%
							for (int ch = 1; ch <= channels; ++ch)
							{
								%>
								<tr>
								<td colspan="2">Mean ch <%=ch%> int.</td>
								<%
								for (AnnotationGroup ag : summary.getAnnotationGroups())
								{
									%>
									<td class="value" style="background: <%=ag.getColor()%>;"
										id="mean.<%=at.getId()%>.<%=ag.getId()%>.ch<%=ch%>"></td>
									<%
								}
								%>
								</tr>
								<%
							}
							if (hasRatio)
							{
								%>
								<tr>
								<td colspan="2" title="The geometric mean of the ratios">G. mean ratio</td>
								<%
								for (AnnotationGroup ag : summary.getAnnotationGroups())
								{
									%>
									<td class="value" style="background: <%=ag.getColor()%>;"
										id="gmean.<%=at.getId()%>.<%=ag.getId()%>"></td>
									<%
								}
								%>
								</tr>
								<tr>
								<td colspan="2" title="Standard deviation of log2 ratios">log2ratio SD</td>
								<%
								for (AnnotationGroup ag : summary.getAnnotationGroups())
								{
									%>
									<td class="value" style="background: <%=ag.getColor()%>;"
										id="sd.<%=at.getId()%>.<%=ag.getId()%>"></td>
									<%
								}
								%>
								</tr>
								<%
							}
							%>
							<tr>
							<td colspan="2" title="The number of spots falling in this group">Count</td>
							<%
							for (AnnotationGroup ag : summary.getAnnotationGroups())
							{
								%>
								<td class="value" style="background: <%=ag.getColor()%>;"
									id="count.<%=at.getId()%>.<%=ag.getId()%>"></td>
								<%
							}
							%>
							</tr>
						</table>
						<%
					}
				}
				%>
				</form>
		</base:section>

		<form name="spotIndex" action="index.jsp" method="post">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="bioassayset_id" value="<%=bioAssaySetId%>">
		<input type="hidden" name="cmd" value="SetSpotIndex">
		
			<h4 class="docked">Current spot
			<input name="newSpotIndex" type="text" class="text" value="<%=positionIndex == -1 ? "all" : positionIndex == -2 ? "avg" : String.valueOf(positionIndex+1)%>" 
				onkeypress="return Numbers.integerOnly(event, true, validateSpotIndex)"
				size="6" maxlength="8" title="Enter a number between 1 and <%=matchingPositions%>">
				of <%=matchingPositions%>
			
				<%
				if (positionIndex == 0)
				{
					%>
					<base:icon image="first_gray.gif" />
					<%
				}
				else
				{
					%>
					<a href="index.jsp?ID=<%=ID%>&cmd=SetSpotIndex&bioassayset_id=<%=bioAssaySetId%>&spotIndex=0"
						title="Go the first position"><base:icon image="first.gif" /></a>
					<%
				}
				if (positionIndex <= 0)
				{
					%>
					<base:icon image="previous_gray.gif" />
					<%
				}
				else
				{
					%>
					<a href="index.jsp?ID=<%=ID%>&cmd=SetSpotIndex&bioassayset_id=<%=bioAssaySetId%>&spotIndex=<%=positionIndex-1%>"
						title="Go the previous position"><base:icon image="previous.gif" /></a>
					<%
				}
				%>
				&nbsp;&nbsp;
				<%
				if (positionIndex == matchingPositions - 1 || positionIndex < 0)
				{
					%>
					<base:icon image="next_gray.gif" />
					<%
				}
				else
				{
					%>
					<a href="index.jsp?ID=<%=ID%>&cmd=SetSpotIndex&bioassayset_id=<%=bioAssaySetId%>&spotIndex=<%=positionIndex+1%>"
						title="Go the next position"><base:icon image="next.gif" /></a>
					<%
				}
				if (positionIndex == matchingPositions - 1)
				{
					%>
					<base:icon image="last_gray.gif" />
					<%
				}
				else
				{
					%>
					<a href="index.jsp?ID=<%=ID%>&cmd=SetSpotIndex&bioassayset_id=<%=bioAssaySetId%>&spotIndex=<%=matchingPositions-1%>"
						title="Go the last position"><base:icon image="last.gif" /></a>
					<%
				}
				%>
				[ <a href="index.jsp?ID=<%=ID%>&cmd=SetSpotIndex&bioassayset_id=<%=bioAssaySetId%>&spotIndex=-1"
					title="Show all positions">all</a>
				| <a href="index.jsp?ID=<%=ID%>&cmd=SetSpotIndex&bioassayset_id=<%=bioAssaySetId%>&spotIndex=-2"
					title="Calculate average values for each bioassay">avg</a>
				]
				</h4>
			
			</form>
		<%
		if (cc.getMessage() != null)
		{
			%>
			<div class="error"><%=cc.getMessage()%></div>
			<%
			cc.setMessage(null);
		}
		%>
		
		<%
		if (spotData != null)
		{
			Formatter<Number> numberFormatter = FormatterFactory.getNumberFormatter(sc);
			%>

		<tbl:table 
			id="spotdata" 
			clazz="itemlist" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			title="<%=title%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			subcontext="<%=subContext%>"
			>
			<tbl:hidden 
				name="bioassayset_id" 
				value="<%=String.valueOf(bioAssaySetId)%>" 
			/>
			<%
			for (AnnotationType at : selectedAnnotationTypes.keySet())
			{
				%>
				<tbl:columndef
					id="<%="annotation." + at.getId()%>"
					title="<%=HTML.encodeTags(at.getName()) %>"
					show="always"
				/>
				<%
			}
			%>
			<tbl:columndef
				id="bioassay"
				property="COLUMN"
				title="Bioassay"
				show="always"
				sortable="true"
			/>
			<tbl:columndef
				id="position"
				property="POSITION"
				title="Position"
				show="<%=isAveraging ? "never" : "always" %>"
				sortable="true"
			/>
			<tbl:columndef
				id="count"
				title="Count"
				show="<%=isAveraging ? "always" : "never" %>"
			/>
			<%
			for (int ch = 1; ch <= channels; ++ch)
			{
				%>
				<tbl:columndef
					id="<%="ch"+ch%>"
					property="<%="%"+ch%>"
					datatype="float"
					title="<%="Ch " + ch%>"
					tooltip="<%=transform.isTransformed() ? transform.toString() : null %>"
					sortable="true"
					filterable="true"
					exportable="true"
					formatter="<%=numberFormatter%>"
				/>
				<%
			}
			%>
			<%
			for (TableColumn tc : columns)
			{
				%>
				<tbl:columndef
					id="<%=tc.getId()%>"
					property="<%=tc.getProperty()%>"
					datatype="<%=tc.getDatatype().getStringValue()%>"
					title="<%=HTML.encodeTags(tc.getTitle())%>"
					sortable="<%=tc.getSortable()%>"
					filterable="<%=tc.getFilterable()%>"
					exportable="<%=tc.getExportable()%>"
					show="<%=!isAveraging || tc.isAveragable() ? tc.getShow() : "never"%>"
					formatter="<%=tc.getFormatter()%>"
				/>
				<%
			}
			%>
				
			<tbl:toolbar>
				<tbl:button 
					image="columns.gif" 
					onclick="configureColumns()" 
					title="Columns&hellip;" 
					tooltip="Show, hide and re-order columns" 
				/>
				<tbl:button 
					image="plotter.gif"
					onclick="assayPlot()"
					title="Plot&hellip;"
					tooltip="Plot selected data from this table"
				/>
			</tbl:toolbar>
			<tbl:data>
				<tbl:columns />
				<tbl:rows>
				<%
				int index = 0;
				float[] intensity = new float[channels+1];
				while (spotData.hasNext())
				{
					SqlResult item = spotData.next();
					index++;
					BioAssay bioAssay = explorer.getBioAssay(dc, item.getShort(1));
					for (int ch = 1; ch <= channels; ++ch)
					{
						intensity[ch] = item.getFloat(2+ch);
					}
					%>
					<tbl:row>
						<%
						for (Map.Entry<AnnotationType, AnnotationSummary> entry : selectedAnnotationTypes.entrySet())
						{
							AnnotationType at = entry.getKey();
							AnnotationGroup annotationGroup = entry.getValue().getAnnotationGroup(bioAssay.getDataCubeColumnNo());
							String allValues = annotationGroup.getTitle();
							if (hasRatio)
							{
								float logRatio = (float)(Math.log(transform.unTransform(intensity[1]) / transform.unTransform(intensity[2])));
								annotationGroup.addStatistics("logratio", logRatio);
								annotationGroup.addStatistics("logratio2", logRatio * logRatio);
							}
							for (int ch = 1; ch <= channels; ++ch)
							{
								annotationGroup.addValue(ch, (float)transform.unTransform(intensity[ch]));
							}
							%>
							<tbl:cell column="<%="annotation."+at.getId()%>" style="<%="background: "+annotationGroup.getColor()+";"%>">
							<%=allValues%>
							</tbl:cell>
							<%
						}
						%>
						<tbl:cell column="bioassay"><%=Base.getLinkedName(ID, bioAssay, false, true)%></tbl:cell>
						<tbl:cell column="position"><%=item.getInt(2)%></tbl:cell>
						<tbl:cell column="count"><%=item.getInt(2)%></tbl:cell>
						<%
						for (int ch = 1; ch <= channels; ++ch)
						{
							%>
							<tbl:cell column="<%="ch" + ch%>" value="<%=intensity[ch]%>" />
							<%
						}
						%>
						<%
						int colIndex = 3 + channels;
						for (String columnId : selected.selectedIds)
						{
							%>
							<tbl:cell column="<%=columnId%>" value="<%=item.getObject(colIndex++)%>" />
							<%
						}
						%>
					</tbl:row>
					<%
				}
			%>
			</tbl:rows>
			</tbl:data>
			</tbl:table>
			</div>
			<%
			}
			%>
			<script language="JavaScript">
			function init()
			{
				<%
				for (Map.Entry<AnnotationType, AnnotationSummary> entry : selectedAnnotationTypes.entrySet())
				{
					AnnotationType at = entry.getKey();
					AnnotationSummary summary = entry.getValue();
					%>
					<%
					for (AnnotationGroup ag : summary.getAnnotationGroups())
					{
						for (int ch = 1; ch <= channels; ++ch)
						{
							%>
							var div = document.getElementById('mean.<%=at.getId()%>.<%=ag.getId()%>.ch<%=ch%>');
							div.innerHTML = '<%=Values.formatNumber(ag.getMean(ch), 2)%>';
							<%
						}
						%>
						var div = document.getElementById('count.<%=at.getId()%>.<%=ag.getId()%>');
						div.innerHTML = '<%=ag.getCount(1)%>';
						<%
						if (hasRatio)
						{
							float r = ag.getStatistics("logratio");
							int count = ag.getCount(1);
							float gMean = count > 0 ? (float)Math.exp(r / count) : Float.NaN;
							float sd = count > 1 ? 
								(float)Math.sqrt((ag.getStatistics("logratio2") - r * (r / count))/(count-1))
								: Float.NaN;
							%>
							var div = document.getElementById('gmean.<%=at.getId()%>.<%=ag.getId()%>');
							div.innerHTML = '<%=Values.formatNumber(gMean, 2)%>';
							var div = document.getElementById('sd.<%=at.getId()%>.<%=ag.getId()%>');
							div.innerHTML = '<%=Values.formatNumber(sd, 2)%>';
							<%
						}
					}
				}
				%>
				MultiOptions.init();
				var options = new Array();
				<%
				if (annotationTypes != null)
				{
					for (AnnotationType at : annotationTypes)
					{
						String isSelected = selectedAnnotationTypes.containsKey(at) ? "true" : "false";
						%>
						options[options.length] = {key:'<%=at.getId()%>', value:'<%=HTML.javaScriptEncode(at.getName())%>', selected:<%=isSelected%>};
						<%
					}
				}
				%>
				MultiOptions.enableForField('annotationSummary', 'display:annotationTypes', 'annotationtype_id', 1, options);
			}
			Main.onLoad(init);
			</script>
			
			</t:tab>
			</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (spotData != null) spotData.close();
	if (dc != null) dc.close();
}

%>
